commit 2b4e646abb110d8cb9c89dfb6969e8f35010833a
Author: freddy77 <freddy77>
Date:   Tue Dec 15 09:53:26 2009 +0000

    Avoid wrong configuration problem reporting problems

diff --git a/ChangeLog b/ChangeLog
index 07942cf..a2020ac 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Dec 15 10:52:43 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/connectparams.c src/odbc/odbc.c:
+	- Avoid wrong configuration problem reporting problems
+
 Tue Dec 15 10:13:12 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/connectparams.c:
 	- Update Unixodbc configuration settings for TDS version
@@ -1982,4 +1986,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2905 2009/12/15 09:13:45 freddy77 Exp $
+$Id: ChangeLog,v 1.2906 2009/12/15 09:53:26 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 3997a0e..231008d 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.113 2008/10/23 15:07:48 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.114 2009/12/15 09:53:27 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -433,8 +433,8 @@ BOOL get_login_info(HWND hwndParent, TDSCONNECTION * connection);
  * \param connection          structure where to store informations
  * \return 0 if error, 1 otherwise
  */
-int odbc_parse_connect_string(const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection);
-int odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection);
+int odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection);
+int odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection);
 
 /*
  * convert_tds2sql.c
diff --git a/src/odbc/connectparams.c b/src/odbc/connectparams.c
index f7739f2..99ead31 100644
--- a/src/odbc/connectparams.c
+++ b/src/odbc/connectparams.c
@@ -37,7 +37,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: connectparams.c,v 1.78 2009/12/15 09:13:46 freddy77 Exp $");
+TDS_RCSID(var, "$Id: connectparams.c,v 1.79 2009/12/15 09:53:27 freddy77 Exp $");
 
 static const char odbc_param_Servername[] = "Servername";
 static const char odbc_param_Address[] = "Address";
@@ -111,20 +111,24 @@ static int SQLGetPrivateProfileString(LPCSTR pszSection, LPCSTR pszEntry, LPCSTR
 #endif
 
 static int
-parse_server(char *server, TDSCONNECTION * connection)
+parse_server(TDS_DBC *dbc, char *server, TDSCONNECTION * connection)
 {
 	char ip[64];
 	char *p = (char *) strchr(server, '\\');
 
 	if (p) {
-		if (!tds_dstr_copy(&connection->instance_name, p+1))
+		if (!tds_dstr_copy(&connection->instance_name, p+1)) {
+			odbc_errs_add(&dbc->errs, "HY001", NULL);
 			return 0;
+		}
 		*p = 0;
 	}
 
 	tds_lookup_host(server, ip);
-	if (!tds_dstr_copy(&connection->ip_addr, ip))
+	if (!tds_dstr_copy(&connection->ip_addr, ip)) {
+		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		return 0;
+	}
 
 	return 1;
 }
@@ -143,21 +147,30 @@ myGetPrivateProfileString(const char *DSN, const char *key, char *buf)
  * @return 1 if success 0 otherwhise
  */
 int
-odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection)
+odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
 {
 	char tmp[FILENAME_MAX];
 	int freetds_conf_less = 1;
-	int address_specified = 0;
 
 	/* use old servername */
 	if (myGetPrivateProfileString(DSN, odbc_param_Servername, tmp) > 0) {
 		freetds_conf_less = 0;
 		tds_dstr_copy(&connection->server_name, tmp);
 		tds_read_conf_file(connection, tmp);
+		if (myGetPrivateProfileString(DSN, odbc_param_Server, tmp) > 0) {
+			odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and SERVER");
+			return 0;
+		}
+		if (myGetPrivateProfileString(DSN, odbc_param_Address, tmp) > 0) {
+			odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and ADDRESS");
+			return 0;
+		}
 	}
 
 	/* search for server (compatible with ms one) */
 	if (freetds_conf_less) {
+		int address_specified = 0;
+
 		if (myGetPrivateProfileString(DSN, odbc_param_Address, tmp) > 0) {
 			address_specified = 1;
 			/* TODO parse like MS */
@@ -167,7 +180,7 @@ odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection)
 		if (myGetPrivateProfileString(DSN, odbc_param_Server, tmp) > 0) {
 			tds_dstr_copy(&connection->server_name, tmp);
 			if (!address_specified) {
-				if (!parse_server(tmp, connection))
+				if (!parse_server(dbc, tmp, connection))
 					return 0;
 			}
 		}
@@ -218,11 +231,12 @@ odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection)
  * @return 1 if success 0 otherwhise
  */
 int
-odbc_parse_connect_string(const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection)
+odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection)
 {
 	const char *p, *end;
 	DSTR *dest_s, value;
-	int reparse = 0;	/* flag for indicate second parse of string */
+	enum { CFG_DSN = 1, CFG_SERVER = 2, CFG_SERVERNAME = 4 };
+	unsigned int cfgs = 0;	/* flags for indicate second parse of string */
 	char option[16];
 
 	tds_dstr_init(&value);
@@ -266,31 +280,52 @@ odbc_parse_connect_string(const char *connect_string, const char *connect_string
 		if (!end)
 			end = connect_string_end;
 
-		if (!tds_dstr_copyn(&value, p, end - p))
+		if (!tds_dstr_copyn(&value, p, end - p)) {
+			odbc_errs_add(&dbc->errs, "HY001", NULL);
 			return 0;
+		}
 
 		if (strcasecmp(option, "SERVER") == 0) {
-			/* ignore if servername or DSN specified */
-			if (!reparse) {
+			/* error if servername or DSN specified */
+			if ((cfgs & (CFG_DSN|CFG_SERVERNAME)) != 0) {
+				tds_dstr_free(&value);
+				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				return 0;
+			}
+			if (!cfgs) {
 				dest_s = &connection->server_name;
 				/* not that safe cast but works -- freddy77 */
-				if (!parse_server((char *) tds_dstr_cstr(&value), connection)) {
+				if (!parse_server(dbc, (char *) tds_dstr_cstr(&value), connection)) {
 					tds_dstr_free(&value);
 					return 0;
 				}
+				cfgs = CFG_SERVER;
 			}
 		} else if (strcasecmp(option, "SERVERNAME") == 0) {
-			if (!reparse) {
+			if ((cfgs & (CFG_DSN|CFG_SERVER)) != 0) {
+				tds_dstr_free(&value);
+				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				return 0;
+			}
+			if (!cfgs) {
 				tds_dstr_dup(&connection->server_name, &value);
 				tds_read_conf_file(connection, tds_dstr_cstr(&value));
-				reparse = 1;
+				cfgs = CFG_SERVERNAME;
 				p = connect_string;
 				continue;
 			}
 		} else if (strcasecmp(option, "DSN") == 0) {
-			if (!reparse) {
-				odbc_get_dsn_info(tds_dstr_cstr(&value), connection);
-				reparse = 1;
+			if ((cfgs & (CFG_SERVER|CFG_SERVERNAME)) != 0) {
+				tds_dstr_free(&value);
+				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				return 0;
+			}
+			if (!cfgs) {
+				if (!odbc_get_dsn_info(dbc, tds_dstr_cstr(&value), connection)) {
+					tds_dstr_free(&value);
+					return 0;
+				}
+				cfgs = CFG_DSN;
 				p = connect_string;
 				continue;
 			}
@@ -344,7 +379,7 @@ odbc_parse_connect_string(const char *connect_string, const char *connect_string
 	}
 
 	tds_dstr_free(&value);
-	return p != NULL;
+	return 1;
 }
 
 #if !HAVE_SQLGETPRIVATEPROFILESTRING
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 51f2693..9edba50 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.517 2009/11/29 18:56:47 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.518 2009/12/15 09:53:27 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -447,7 +447,7 @@ SQLDriverConnect(SQLHDBC hdbc, SQLHWND hwnd, SQLCHAR FAR * szConnStrIn, SQLSMALL
 		tds_dstr_dup(&connection->database, &dbc->attr.current_catalog);
 
 	/* parse the DSN string */
-	odbc_parse_connect_string((const char *) szConnStrIn, (const char *) szConnStrIn + conlen, connection);
+	odbc_parse_connect_string(dbc, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen, connection);
 
 	/* add login info */
 	if (hwnd) {
@@ -1716,9 +1716,8 @@ SQLConnect(SQLHDBC hdbc, SQLCHAR FAR * szDSN, SQLSMALLINT cbDSN, SQLCHAR FAR * s
 		tds_dstr_copy(&dbc->dsn, "DEFAULT");
 
 
-	if (!odbc_get_dsn_info(tds_dstr_cstr(&dbc->dsn), connection)) {
+	if (!odbc_get_dsn_info(dbc, tds_dstr_cstr(&dbc->dsn), connection)) {
 		tds_free_connection(connection);
-		odbc_errs_add(&dbc->errs, "IM007", "Error getting DSN information");
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
 

